      program jac
c
      parameter (n=4000, itmax=1000)
      real*8 a(n,n),c(n,n), f(n,n), oldbuf(n, n)
      integer i,j,t, b1, b2
      real*8 resid, error, TIMER_END
      integer itmaxin, outmax, k, iargc
      character argv*10
      real*8 alpha, tol, init 
      integer low, high,chunk,tid
      integer omp_get_num_threads, omp_get_thread_num
c

      tol = init(a,n,f)

      ! read argument
      k = iargc()
      if (k .ge. 1) then
        call getarg(1, argv)
        read (argv,'(I10)') itmaxin
       else
        itmaxin = 8
      end if 
      if (k .ge. 2) then
        call getarg(2, argv)
        read (argv, '(I10)') b1 
        b2 = b1
      else
        b1 = 30
        b2 = 30
      end if
       
      outmax = itmax
      
      call TIMER_BEGIN()


      do k = 1, outmax

!$omp parallel default(shared) 
     > private(i,j,ii,t,jj,chunk,low,high,tid,resid)

      chunk = ((n-2)/omp_get_num_threads())
      tid = omp_get_thread_num()
      low = max(tid * chunk, 2)
      high = min((tid+1)*chunk-1, n-1)
      if (tid .eq. omp_get_num_threads()-1) then
         high = n-1
      endif

      do  jj = low, high+itmaxin,b1
      do  ii = 2, n+itmaxin-1,b2
        do  t = 1, itmaxin
             do j = max(low,jj-t),
     > min(int(jj+b1-t-1),int(high))
             do i = max(2,ii-t),min(int(ii+b2-t-1),int(n-1))
                a(i,j)=(a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4 - f(i, j)
	     end do
	     end do
       end do	   
      end do
      end do

!$omp end parallel
 	    error = 0.D0
!$omp parallel do private(resid) reduction(+:error)
        do j = 2, n-1
        do i = 2, n-1
          resid=a(i,j)-((a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4-f(i,j))
          error=error + resid * resid
        end do
        end do
	  error = sqrt(error)	  

      if (error .le. tol) then 		    
 		exit 	
	  end if
      end do
   10 continue

      print *, 'Time:', TIMER_END()
	  print *, 'Iteration:', k * itmaxin
      print *, 'Inner Iteration:', itmaxin      
      print *, 'Block Size:', b1
	  call output(a,n,f)
c
      stop 
      end
c
