#!/bin/bash
OPTION='-O3 -openmp mytimer.c.o pde.f90'
export OMP_NUM_THREADS=16

# compile and run

#echo 'parallel asynchronous block'
#ifort $OPTION gs-dup-2d-par.f -o gs-dup-2d-par >compile.log
#time gs-dup-2d-par

sleep 2

echo 'parallel'
ifort $OPTION rbgs-par-nobk.f -o rbgs-par-nobk >>compile.log
time rbgs-par-nobk

sleep 2

echo 'parallel blocking'
ifort $OPTION rbgs-par-bk.f -o rbgs-par-bk >>compile.log
time rbgs-par-bk 41 840

echo 'parallel blocking no recovery'
ifort $OPTION rbgs-par-bk-norev.f -o rbgs-par-bk-norev >>compile.log
time rbgs-par-bk-norev 126 840

sleep 2
echo 'parallel asynchronous nonblocking'
ifort $OPTION gs-par-nobk-async.f -o gs-par-nobk-async >>compile.log
time gs-par-nobk-async

sleep 2
echo 'parallel asynchronous blocking'
ifort $OPTION gs-par-bk-async.f -o gs-par-bk-async >>compile.log
time gs-par-bk-async 80 130

sleep 2
echo 'parallel asynchronous blocking adaptive'
ifort $OPTION gs-par-bk-async-adaptive.f -o gs-par-bk-async-adaptive >>compile.log
time gs-par-bk-async-adaptive 80 130
