      program jac
c
      parameter (n=3000, itmax=100, b1=30, b2=30, pad=204)
c      integer n,itmax, b1, b2, pad 
c#ifdef PAD
c      common a(n,n),tt(pad),c(n,n)
c#else
      common a(n,n),c(n,n)
c#endif
      real*8 a, tt, c
      integer i,j,ii,jj,t
      INTRINSIC    min, max
      integer itmaxin, outmax, k

      itmaxin = 2 
      outmax = 50 
   
c
      call init(a,n)
c
c

!$omp parallel do private(i)
      do 2 i = 1, n
        c(1:n, i) = a(1:n, i)
    2 continue

!$omp parallel default(shared) private(ii, jj, i, h, t, k)
      do k = 1, outmax

!$omp do
      do  jj = 2, n+itmax-2,b1
      do  ii = 2, n+itmax-2,b2
        do  t = max(1,min(jj,ii)-n+2),
     >     min(int(max(jj+b1,ii+b2)-2),int(itmaxin))
          if (mod(t,2).eq.1) then
             do j = max(2,jj-t+1),min(int(jj+b1-t),int(n-1))
             do i = max(2,ii-t+1),min(int(ii+b2-t),int(n-1))
                c(i,j)=(a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4
	     end do
	     end do
          else
             do j = max(2,jj-t+1),min(int(jj+b1-t),int(n-1))
             do i = max(2,ii-t+1),min(int(ii+b2-t),int(n-1))
                a(i,j)=(c(i+1,j)+c(i-1,j)+c(i,j+1)+c(i,j-1))/4
	     end do
	     end do
          end if
	end do
      end do
      end do
      end do
!$omp end parallel

      call output(a,n)
c
      stop
      end
c
      subroutine init(a,n)
      integer n
      real*8 a(n,n)
      integer i,j
c
!$omp parallel do default(shared) private(i, j)
      do 100 j = 1,n
      do 100 i = 1,n
        a(i,j) = (i**2-j*2)
  100 continue
      return
      end
      subroutine output(a,n)
      integer n
      real*8 a(n,n)
      integer i, j
      real*8 resid, error
c
      resid = 0.D0
      error = 0.D0
!$omp parallel do default(shared) private(i,j, resid) reduction(+:error)
      do j = 2, n-1
        do i = 2, n-1
           resid=abs((a(i+1,j)+a(i-1,j)+a(i,j+1)+
     >    a(i,j-1))/4-a(i,j))
           error = error + resid * resid
        end do
      end do

      error = sqrt(error)
      print *,'Residual is:', error
      return
      end
