C   JACOBI KERNEL IMPLEMENTAION
      PROGRAM JAC
C
      PARAMETER (N=1279, ITMAX=100, EPS = 0.D0)
      REAL*8   A(N,N),B(N,N),TARRAY(2),C(N,N)
      INTEGER  I,J,JJ,T,ACCUM,LMAX,NSTEP
      REAL*8   TMP(ITMAX)
C
C   INITIALIZATION 
      CALL INIT(A,N)
C
C   MAJOR COMPUTATION
C     TIME1 = DTIME(TARRY)
      NSTEP = 7
      LMAX = NSTEP
      IF (LMAX .GT. ITMAX) LMAX=ITMAX 
      ACCUM = 0
C   INITIALIZE THE BACKUP COPY
      DO 1 J = 1, N
	DO 1 I = 1, N
	  C(I,J) = A(I,J)
    1 CONTINUE
C   INITIALIZE THE ODD-COPY
      DO 2 I = 1,N
	B(I,1) = A(I,1)
	B(I,N) = A(I,N)
    2 CONTINUE
      DO 3 I = 2,N-1
	B(1,I) = A(1,I)
	B(N,I) = A(N,I)
    3 CONTINUE
C
      DO 5 CTRL = 1, (ITMAX+LMAX-1)/LMAX
C   RUN UP TO LMAX ITERATIONS
	DO 9  J = ACCUM+1,ACCUM+LMAX
	  TMP(J) = 0.D0
    9   CONTINUE
        DO 10 JJ = 2,N+LMAX-2,NSTEP
          DO 15 T = MAX(1,JJ-N+2),MIN(JJ+NSTEP-2,LMAX)
            IF (MOD(T+ACCUM,2) .EQ. 1) THEN
              DO 60 J = MAX(2,JJ-T+1),MIN(JJ+NSTEP-T,N-1)
                DO 20 I = 2,N-1
                  B(I,J) = (A(I+1,J)+A(I-1,J)+A(I,J+1)
     >             +A(I,J-1))/4
		  TMP(T+ACCUM) = TMP(T+ACCUM) + ABS(B(I,J) - A(I,J))
   20           CONTINUE
   60         CONTINUE
            ELSE
              DO 70 J = MAX(2,JJ-T+1),MIN(JJ+NSTEP-T,N-1)
                DO 30 I = 2,N-1
                  A(I,J) = (B(I+1,J)+B(I-1,J)+B(I,J+1)
     >             +B(I,J-1))/4
		  TMP(T+ACCUM) = TMP(T+ACCUM) + ABS(A(I,J) - B(I,J))
   30           CONTINUE
   70         CONTINUE
            END IF
   15     CONTINUE
   10   CONTINUE
	DO 51 I = 1, LMAX-1
	  IF (TMP(ACCUM+I).LE.EPS)  GOTO 91
   51   CONTINUE
	IF (TMP(ACCUM+LMAX).LE.EPS) THEN
	  T = ACCUM+LMAX
	  IF (MOD(T, 2).EQ.1) THEN
	     DO 33 J = 2, N-1
	       DO 33 I = 2, N-1
	         A(I,J) = B(I,J)
   33	     CONTINUE
	  END IF
	  GOTO 92
	END IF
C
	ACCUM = ACCUM + LMAX
	IF (ITMAX.EQ.ACCUM) THEN
	  IF (MOD(ITMAX,2).EQ.1) THEN
	    DO 34 J = 2, N-1
	      DO 34 I = 2, N-1
		A(I,J) = B(I,J)
   34	    CONTINUE
	  END IF
	  T = ACCUM+1
	  GOTO 92
	ELSE IF ((ITMAX-ACCUM).LT.LMAX) THEN
	  LMAX = ITMAX-ACCUM
	END IF
	IF (MOD(ACCUM,2).EQ.1) THEN
	  DO 81 J = 2, N-1
	    DO 81 I = 2, N-1
	      C(I,J) = B(I,J)
   81	  CONTINUE
	ELSE
	  DO 82 J = 2, N-1
	    DO 82 I = 2, N-1
	      C(I,J) = A(I,J)
   82     CONTINUE
	END IF
C 
    5 CONTINUE
      T = ITMAX+1
      GOTO 92
C     ROLLBACK
   91 T = ACCUM+1
      TMP(T) = 0.D0
      DO 25 J = 2,N-1
        DO 25 I = 2,N-1
          B(I,J) = (C(I+1,J)+C(I-1,J)+C(I,J+1)+C(I,J-1))/4
   25 CONTINUE
      DO 35 J = 2,N-1
        DO 35 I = 2,N-1
	  TMP(T) = TMP(T) + ABS(A(I,J) - B(I,J))
          A(I,J) = B(I,J)
   35 CONTINUE
      IF (TMP(T).LE.EPS) GOTO 92
C     THE REST OF ITERATIONS
      DO 12 T = ACCUM+2,ACCUM+LMAX
   	TMP(T) = 0.D0
        DO 23 J = 2,N-1
          DO 23 I = 2,N-1
            B(I,J) = (A(I+1,J)+A(I-1,J)+A(I,J+1)+A(I,J-1))/4
   23   CONTINUE
        DO 37 J = 2,N-1
          DO 37 I = 2,N-1
	    TMP(T) = TMP(T) + ABS(A(I,J) - B(I,J))
            A(I,J) = B(I,J)
   37   CONTINUE
	IF (TMP(T).LE.EPS) GOTO 92
   12 CONTINUE
C
   92 CALL OUTPUT(A,N)
      STOP
      END
C
      SUBROUTINE INIT(A,N)
      INTEGER N
      REAL*8 A(N,N)
      INTEGER I2,I1
C
      DO 100 I2 = 1,N
	DO 100 I1 = 1,N
	  A(I1,I2) = (I1**2-I2*2)
  100 CONTINUE
C
      RETURN
      END
C
      SUBROUTINE OUTPUT(A,N)
      INTEGER N
      REAL*8 A(N,N)
      INTEGER I1
C
C   OUTPUT THE DIAGONAL
C
      DO 110 I1 = 1,N
	PRINT 120, I1, I1, A(I1,I1)
  110 CONTINUE
  120 FORMAT('A(',I4,',',I4,') = ',F8.0)
      RETURN
      END

