      program jac
c
      parameter (n=4000, itmax=1000)
      real*8 a(n,n),c(n,n), f(n,n)
      integer i,j,t,gt,k,itmaxin, b1, b2,itmaxin2
      real*8 resid, error, TIMER_END, alpha
      real*8 gerror
      character argv*10
      integer gb1, gb2,low,high,chunk,tid
      integer omp_get_thread_num, omp_get_num_threads
      real*8 tol, init
c
      tol = init(a,n,f)
     
      t = iargc()
      if (t .ge. 1) then
        call getarg(1, argv)
        read (argv, '(I10)') itmaxin
      else
        itmaxin = 8
      end if 
      if (t .ge. 2) then
        call getarg(2, argv)
        read (argv, '(I10)') b1
        b2 = b1
      else
        b1 = 30
        b2 = 30
      end if
      if (t .ge. 3) then
        call getarg(3, argv)
        read (argv, '(I10)') itmaxin2
      else
        itmaxin2 = 1 
      end if

      call TIMER_BEGIN()
      t = 1

      error = 10 * tol
      gt = 0
!$omp parallel do default(shared) private(i, j)
      do 2 i = 1, n
        c(1, i) = a(1, i)
        c(n, i) = a(n, i)
        c(i, 1) = a(i, 1)
        c(i, n) = a(i, n)
    2 continue

      do k = 1, itmax

!$omp parallel default(shared) 
     > private(i,j,ii,t,jj,chunk,low,high,tid,error,resid)
 
      chunk = ((n-2)/omp_get_num_threads())
      tid = omp_get_thread_num()
      low = max(tid * chunk, 2)
      high = min((tid+1)*chunk-1, n-1)
      if (tid .eq. omp_get_num_threads()-1) then
         high = n-1
      endif
     
      do  jj = low, high+itmaxin-1,b1
      do  ii = 2, n+itmaxin-2,b2
        do  t = max(1,min(jj-high,ii-n)+2),
     >     min(int(max(jj+b1,ii+b2)-2),int(itmaxin))
          if (mod(t,2).eq.1) then
             do j = max(low,max(2,jj-t+1)),
     >          min(high,min(int(jj+b1-t),int(n-1)))
             do i = max(2,ii-t+1),min(int(ii+b2-t),int(n-1))
                c(i,j)=(a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4 - f(i, j)
         end do
         end do
          else
             do j = max(low,max(2,jj-t+1)),
     >           min(high,min(int(jj+b1-t),int(n-1)))
             do i = max(2,ii-t+1),min(int(ii+b2-t),int(n-1))
                a(i,j)=(c(i+1,j)+c(i-1,j)+c(i,j+1)+c(i,j-1))/4 - f(i, j)        
         end do
         end do
          end if
       end do
      end do
      end do

      if (mod(itmaxin, 2) .eq. 1) then
!$omp do 
         do j = 2, n-1
           do i = 2, n-1
             a(i, j) = c(i, j)
           end do
         end do
      end if
!$omp end parallel

      ! global condition
      error = 0.D0
      gt = itmaxin + gt + itmaxin2
      gb1 = b1 * 4
      gb2 = b2 * 4
      if (itmaxin2 .eq. 1) then
!$omp parallel do default(shared) private(i, j)
         do j = 2, n-1
           do i = 2, n-1
                c(i,j)=(a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4 - f(i, j)
           end do
         end do
      else ! itmaxin2 != 1
      do jj= 2, n+itmaxin2-2,gb1
      do  ii = 2, n+itmaxin2-2,gb2
        do  t = max(1,min(jj,ii)-n+2),
     >     min(int(max(jj+b1,ii+gb2)-2),int(itmaxin2))
          if (mod(t,2).eq.1) then
!$omp parallel do default(shared) private(i, j)
             do j = max(2,jj-t+1),min(int(jj+gb1-t),int(n-1))
             do i = max(2,ii-t+1),min(int(ii+gb2-t),int(n-1))
                c(i,j)=(a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4 - f(i, j)
         end do
         end do
          else
!$omp parallel do default(shared) private(i, j)
             do j = max(2,jj-t+1),min(int(jj+gb1-t),int(n-1))
             do i = max(2,ii-t+1),min(int(ii+gb2-t),int(n-1))
                a(i,j)=(c(i+1,j)+c(i-1,j)+c(i,j+1)+c(i,j-1))/4 - f(i, j)
         end do
         end do
          end if
       end do
      end do
      end do
      end if !itmaxin2 = 1
!$omp parallel do reduction(+:error) default(shared) private(i,j,resid)
        do j = 2,n-1
        do i = 2,n-1
		  resid = a(i,j) - c(i,j)
          if (mod(itmaxin2, 2) .eq. 1) then
            a(i,j) = c(i,j)
          end if
          error = error + resid * resid
        end do
        end do

        error = sqrt(error)
 
        if (error .le. tol) then
           exit
        end if
      end do ! itmax
      print *, 'Time:', TIMER_END()
	  print *, 'Iteration:', gt
	  print *, 'Block:', b1
      print *, 'Inner Iteration:', itmaxin
	  call output(a,n,f)
c
      stop
      end
