      program jac
c
      parameter (n=4000, itmax=1000)
      real*8 a(n,n),c(n,n), f(n,n), oldbuf(n, n)
      integer i,j,t, b1, b2
      real*8 resid, error, TIMER_END
      integer itmaxin, outmax, k, iargc
      character argv*10
      real*8 alpha
      real*8 init, tol
c

      tol = init(a,n,f)

      ! read argument
      k = iargc()
      if (k .ge. 1) then
        call getarg(1, argv)
        read (argv,'(I10)') itmaxin
      else
        itmaxin = 8
      end if 
      if (k .ge. 2) then
        call getarg(2, argv)
        read (argv, '(I10)') b1
        b2 = b1
      else
        b1 = 30
        b2 = 30
      end if
       

      outmax = itmax

      call TIMER_BEGIN()
      
!$omp parallel do private(i)
      do 2 i = 1, n
        c(1, i) = a(1, i)
        c(n, i) = a(n, i)
        c(i, 1) = a(i, 1)
        c(i, n) = a(i, n)
    2 continue

      do k = 1, outmax
      
      do  jj = 2, n+itmaxin-2,b1
      do  ii = 2, n+itmaxin-2,b2
        do  t = max(1,min(jj,ii)-n+2),
     >     min(int(max(jj+b1,ii+b2)-2),int(itmaxin))
          if (mod(t,2).eq.1) then
!$omp parallel do default(shared) private(i, j)
             do j = max(2,jj-t+1),min(int(jj+b1-t),int(n-1))
             do i = max(2,ii-t+1),min(int(ii+b2-t),int(n-1))
                c(i,j)=(a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4 - f(i, j)
	     end do
	     end do
          else
!$omp parallel do default(shared) private(i, j)
             do j = max(2,jj-t+1),min(int(jj+b1-t),int(n-1))
             do i = max(2,ii-t+1),min(int(ii+b2-t),int(n-1))
                a(i,j)=(c(i+1,j)+c(i-1,j)+c(i,j+1)+c(i,j-1))/4 - f(i, j)                
	     end do
	     end do
          end if
       end do	   
      end do
      end do

	    error = 0.D0
!$omp parallel do default(shared) private(i,j,resid) reduction(+:error)
        do 30 j = 2,n-1
        do 30 i = 2,n-1
  	     resid = a(i,j)-c(i, j)         
         if (mod(itmaxin, 2) .eq. 1) then
          a(i, j) = c(i, j)
         end if
        error = error + resid * resid            
   30   continue   

  	  error = sqrt(error)	  

  	  if (error .le. tol) then
		exit 	
	  end if
      end do
   10 continue

      print *, 'Time:', TIMER_END()
	  print *, 'Iteration:', k * itmaxin
      print *, 'Inner Iteration:', itmaxin      
      print *, 'Block Size:', b1
	  call output(a,n,f)
c
      stop
      end
