      program jac
c
      parameter (n=3000, itmax=1000)
      real*8 a(n,n),c(n,n), f(n,n)
      integer i,j,t
c
      call init(a,n)
      
      !$omp parallel do private(xx,yy)
      do j = 1,n
         do i = 1,n
            xx = -1.0 + dble(i-1)/n        ! -1 < x < 1
            yy = -1.0 + dble(j-1)/n        ! -1 < y < 1
            f(i,j) = (-alpha *(1.0-xx*xx)*(1.0-yy*yy)
     &           - 2.0*(1.0-xx*xx)-2.0*(1.0-yy*yy)) /dble(n*n)
         enddo
      enddo
!$omp end parallel do

      
      do 10 t = 1,itmax
!$omp parallel default(shared) private(i, j)

!$omp do
        do 20 j = 2,n-1
        do 20 i = 2,n-1
          c(i,j)=(a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4 - f(i,j) 
   20   continue

!$omp do
        do 30 j = 2,n-1
        do 30 i = 2,n-1
          a(i,j) = c(i,j)
   30   continue
!$omp end parallel
      
   10 continue
	  call output(a,n,f)
c
      stop
      end
c
      subroutine init(a,n)
      integer n
      real*8 a(n,n)
      integer i,j
c
!$omp parallel do default(shared) private(i, j)
      do 100 j = 1,n
      do 100 i = 1,n
        a(i,j) = 0 !(i**2-j*2)
  100 continue
      return
      end
c
      subroutine output(a,n,f)
      integer n
      real*8 a(n,n), f(n,n)
      integer i, j
      real*8 resid, error
c
      resid = 0.D0
      error = 0.D0
!$omp parallel do default(shared) private(i,j, resid) reduction(+:error)
      do j = 2, n-1
        do i = 2, n-1
           resid= abs((a(i+1,j)+a(i-1,j)+a(i,j+1)+
     >    a(i,j-1))/4-a(i,j)-f(i,j))
           error = error + resid * resid
        end do
      end do
      error = sqrt(error)
      print *,'Residual is:', error
      return
      end
