#!/bin/bash
OPTION='-O3 -openmp mytimer.c.o pde.f90'
export OMP_NUM_THREADS=16

# compile and run

#echo 'parallel asynchronous block'
#ifort $OPTION jac-dup-2d-par.f -o jac-dup-2d-par >compile.log
#time jac-dup-2d-par

sleep 2

echo 'parallel'
ifort $OPTION jac-par-nobk.f -o jac-par-nobk >>compile.log
time jac-par-nobk

sleep 2

echo 'parallel blocking'
ifort $OPTION jac-par-bk.f -o jac-par-bk >>compile.log
time jac-par-bk 13 500

echo 'parallel blocking no recovery'
ifort $OPTION jac-par-bk-norev.f -o jac-par-bk-norev >>compile.log
time jac-par-bk-norev 66 500

sleep 2
echo 'parallel asynchronous nonblocking'
ifort $OPTION jac-par-nobk-async.f -o jac-par-nobk-async >>compile.log
time jac-par-nobk-async

sleep 2
echo 'parallel asynchronous blocking'
ifort $OPTION jac-par-bk-async.f -o jac-par-bk-async >>compile.log
time jac-par-bk-async 66 130 4

sleep 2
echo 'parallel asynchronous blocking adaptive'
ifort $OPTION jac-par-bk-async-adaptive.f -o jac-par-bk-async-adaptive >>compile.log
time jac-par-bk-async-adaptive 66 130 4

