      program jac
c
      parameter (n=4000, itmax=1000)
      real*8 a(n,n),c(n,n), f(n,n), oldbuf(n, n)
      integer i,j,t, b1, b2
      real*8 resid, error, TIMER_END
      integer itmaxin, outmax, k, iargc
      character argv*10
      real*8 alpha, tol, init 
      real*8 omega
      omega = 1.2
c

      tol = init(a,n,f)

      ! read argument
      k = iargc()
      if (k .ge. 1) then
        call getarg(1, argv)
        read (argv,'(I10)') itmaxin
       else
        itmaxin = 8
      end if 
      if (k .ge. 2) then
        call getarg(2, argv)
        read (argv, '(I10)') b1 
        b2 = b1
      else
        b1 = 30
        b2 = 30
      end if
       
      outmax = itmax
      
      call TIMER_BEGIN()

      
c!$omp parallel default(shared) private(ii, jj, i, h, t, k)
      do k = 1, outmax

       ! save the old result into buffer      
  	   oldbuf(1:n, 1:n) = a(1:n, 1:n)
       

      do  jj = 2, n+2*itmaxin-1,b1
      do  ii = 2, n+2*itmaxin-1,b2
        do  t = 1, itmaxin
         do j = max(2,jj-2*t+1),min(int(jj+b1-2*t),int(n-1))
         do i = max(2,ii-2*t+1),min(int(ii+b2-2*t),int(n-1))
           if (mod(i+j, 2) .eq. 0) then
          a(i,j)=a(i,j)- omega*(a(i,j)-
     > ((a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4-f(i,j)))
           end if
	     end do
	     end do

         do j = max(2,jj-2*t),min(int(jj+b1-2*t-1),int(n-1))
         do i = max(2,ii-2*t),min(int(ii+b2-2*t-1),int(n-1))
           if (mod(i+j, 2) .eq. 1) then
          a(i,j)=a(i,j)- omega*(a(i,j)-
     > ((a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4-f(i,j))) 
           end if
	     end do
         end do
       end do	   
      end do
      end do

 	    error = 0.D0
        do j = 2, n-1
        do i = 2, n-1
          resid=a(i,j)-((a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4-f(i,j))
          error=error + resid * resid
        end do
        end do

	  error = sqrt(error)	  
 !     print *, error

      if (error .le. tol) then 		    
  	    ! roll back to use buf --recovery

	    do j=1,n
	    do i=1,n
		   a(i, j) = oldbuf(i, j)
        end do
        end do
	    
	    do t = 1,itmax	
	
	  	error = 0.D0
        do j = 2,n-1
        do i = 2,n-1
          if (mod(i+j,2).eq.0) then
          a(i,j)=a(i,j)- omega*(a(i,j)-
     > ((a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4-f(i,j)))
          end if
        end do
        end do

        do j = 2,n-1
        do i = 2,n-1
          if (mod(i+j,2).eq.1) then
          a(i,j)=a(i,j)- omega*(a(i,j)-
     > ((a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4-f(i,j)))
          end if
        end do
        end do


          do j = 2, n-1
          do i = 2, n-1
           resid=a(i,j)-((a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4-f(i,j))
           error=error + resid * resid
          end do
          end do
 
	      error = sqrt(error)	  
		  if (error .le. tol) then 		    
		    exit 
	      end if	  
       end do	  
   
		exit 	
	  end if
      end do
c!$omp end parallel


   10 continue

      print *, 'Time:', TIMER_END()
	  print *, 'Iteration:', (k-1) * itmaxin +t
      print *, 'Inner Iteration:', itmaxin      
      print *, 'Block Size:', b1
	  call output(a,n,f)
c
      stop 
      end
c
