      program jac
c
      parameter (n=4000, itmax=1000)
      real*8 a(n,n),c(n,n), f(n,n), oldbuf(n, n)
      integer i,j,t, b1, b2
      real*8 resid, error, TIMER_END
      integer itmaxin, outmax, k, iargc
      character argv*10
      real*8 alpha, tol, init 
      real*8 omega
      omega = 1.2


      tol = init(a,n,f)

      ! read argument
      k = iargc()
      if (k .ge. 1) then
        call getarg(1, argv)
        read (argv,'(I10)') itmaxin
       else
        itmaxin = 8
      end if 
      if (k .ge. 2) then
        call getarg(2, argv)
        read (argv, '(I10)') b1 
        b2 = b1
      else
        b1 = 30
        b2 = 30
      end if
       
      outmax = itmax
      
      call TIMER_BEGIN()


      do k = 1, outmax

!$omp parallel default(shared) private(i, h, t, k) 
      do t = 1, itmaxin
!$omp do
      do  j = 2, n-1
      do  i = 2, n-1
          a(i,j)=a(i,j)- omega*(a(i,j)-
     > ((a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4-f(i,j)))
      end do
      end do
!$omp end do nowait
      end do
!$omp end parallel
 	    error = 0.D0
!$omp parallel do private(i,j) reduction(+:error)
        do j = 2, n-1
        do i = 2, n-1
          resid=a(i,j)-((a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4-f(i,j))
          error=error + resid * resid
        end do
        end do
	  error = sqrt(error)	  

      if (error .le. tol) then 		    
 		exit 	
	  end if
      end do

   10 continue
      print *, 'Time:', TIMER_END()
	  print *, 'Iteration:', k * itmaxin
      print *, 'Inner Iteration:', itmaxin      
      print *, 'Block Size:', b1
	  call output(a,n,f)
c
      stop 
      end
c
