      program jac
c
      parameter (n=4000, itmax=4000)
      real*8 a(n,n),c(n,n), f(n,n)
      integer i,j,t
      real*8 resid, error, TIMER_END, omega
      real*8 alpha
c
      call init(a,n)
      alpha = 0.D0
      omega = 1.5 
      
      do j = 1,n
         do i = 1,n
            xx = -1.0 + dble(i-1)/n        ! -1 < x < 1
            yy = -1.0 + dble(j-1)/n        ! -1 < y < 1
            f(i,j) = (-alpha *(1.0-xx*xx)*(1.0-yy*yy)
     &           - 2.0*(1.0-xx*xx)-2.0*(1.0-yy*yy)) /dble(n*n)
         enddo
      enddo

      call TIMER_BEGIN()
      
      do j = 2,n-1
      do i = 2,n-1
        resid=a(i,j)-((a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4 - f(i,j)) 
        a(i,j) = a(i,j) - omega*resid
      end do
      end do

      do 10 t = 1,itmax

        error = 0.D0      
!$omp parallel do default(shared) private(i,j,resid)      
      do j = 2,n-1
      do i = 2+mod(j,2),n-1,2
!      do i = 2,n-1
        resid=a(i,j)-((a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4 - f(i,j)) 
        a(i,j) = a(i,j) - omega*resid
      end do
      end do

!$omp parallel do default(shared) private(i,j,resid)      
      do j = 2,n-1
      do i = 2+mod(j+1,2),n-1,2
        resid=a(i,j)-((a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4 - f(i,j)) 
        a(i,j) = a(i,j) - omega*resid
      end do
      end do

!$omp parallel do default(shared) private(i,j,resid) reduction(+:error)     
      do j = 2,n-1
      do i = 2,n-1
        resid=a(i,j)-((a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4 - f(i,j)) 
        error = error + resid * resid
      end do
      end do

	  error = sqrt(error)	  

      print *, error
      if (error .le. 6.97E-4) then 		    
		exit 
      end if
   10 continue

      print *, 'Time:', TIMER_END()
	  print *, 'Iteration:', t
	  call output(a,n,f)
c
      stop
      end
c
      subroutine init(a,n)
      integer n
      real*8 a(n,n)
      integer i,j
c
      do 100 j = 1,n
      do 100 i = 1,n
        a(i,j) = 0 !(i**2-j*2)
  100 continue
      return
      end
c
      subroutine output(a,n,f)
      integer n
      real*8 a(n,n), f(n,n)
      integer i, j
      real*8 resid, error
c
      resid = 0.D0
      error = 0.D0
!$omp parallel do default(shared) private(i,j,resid) reduction(+:error)
      do j = 2, n-1
        do i = 2, n-1
           resid= abs((a(i+1,j)+a(i-1,j)+a(i,j+1)+
     >    a(i,j-1))/4-a(i,j)-f(i,j))
           error = error + resid * resid
        end do
      end do
      error = sqrt(error)
      print *,'Residual is:', error
      return
      end
